import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_opinion {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户id' })
  'user': string = undefined;
  @ApiProperty({ description: '用户昵称' })
  'user_name': string = undefined;
  @ApiProperty({ description: '用户类型' })
  'userType': string = undefined;
  @ApiProperty({ description: '问题类型' })
  'type': string = undefined;
  @ApiProperty({ description: '问题描述' })
  'brief': string = undefined;
  @ApiProperty({ description: '时间' })
  'time': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '图片' })
  'file': Array<any> = undefined;
}

export class QDTO_opinion extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user', 'userType', 'type', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户id' })
  'user': string = undefined;
  @ApiProperty({ description: '用户类型' })
  'userType': string = undefined;
  @ApiProperty({ description: '问题类型' })
  'type': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_opinion extends FVO_opinion {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_opinion {
  @ApiProperty({ description: '用户id' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '用户类型' })
  @Rule(RuleType['string']().empty(''))
  'userType': string = undefined;
  @ApiProperty({ description: '问题类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '问题描述' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '图片' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
}

export class CVO_opinion extends FVO_opinion {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_opinion extends CDTO_opinion {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_opinion extends FVO_opinion {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
