import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_order {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户id' })
  'student': string = undefined;
  @ApiProperty({ description: '课程id' })
  'course': string = undefined;
  @ApiProperty({ description: '总金额' })
  'total': number = undefined;
  @ApiProperty({ description: '下单时间' })
  'buy_time': string = undefined;
  @ApiProperty({ description: '订单号' })
  'no': string = undefined;
  @ApiProperty({ description: '支付数据' })
  'pay': string = undefined;
  @ApiProperty({ description: '订单状态' })
  'status': string = undefined;
}

export class QDTO_order extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['student', 'course', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户id' })
  'student': string = undefined;
  @ApiProperty({ description: '课程id' })
  'course': string = undefined;
  @ApiProperty({ description: '订单状态' })
  'status': string = undefined;
}

export class QVO_order extends FVO_order {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_order {
  @ApiProperty({ description: '用户id' })
  @Rule(RuleType['string']().empty(''))
  'student': string = undefined;
  @ApiProperty({ description: '课程id' })
  @Rule(RuleType['string']().empty(''))
  'course': string = undefined;
  @ApiProperty({ description: '总金额' })
  @Rule(RuleType['number']().empty(''))
  'total': number = undefined;
  @ApiProperty({ description: '下单时间' })
  @Rule(RuleType['string']().empty(''))
  'buy_time': string = undefined;
  @ApiProperty({ description: '订单号' })
  @Rule(RuleType['string']().empty(''))
  'no': string = undefined;
  @ApiProperty({ description: '支付数据' })
  @Rule(RuleType['string']().empty(''))
  'pay': string = undefined;
  @ApiProperty({ description: '订单状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_order extends FVO_order {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_order extends CDTO_order {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_order extends FVO_order {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
