import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_student {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '微信唯一标书' })
  'openid': string = undefined;
  @ApiProperty({ description: '头像' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '昵称' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '年龄' })
  'age': string = undefined;
  @ApiProperty({ description: '年级' })
  'grade': string = undefined;
  @ApiProperty({ description: '出生日期' })
  'birth': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_student extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['openid', 'nick_name', 'gender', 'age', 'grade', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '微信唯一标书' })
  'openid': string = undefined;
  @ApiProperty({ description: '昵称' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '年龄' })
  'age': string = undefined;
  @ApiProperty({ description: '年级' })
  'grade': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_student extends FVO_student {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_student {
  @ApiProperty({ description: '微信唯一标书' })
  @Rule(RuleType['string']().empty(''))
  'openid': string = undefined;
  @ApiProperty({ description: '头像' })
  @Rule(RuleType['array']().empty(''))
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '昵称' })
  @Rule(RuleType['string']().empty(''))
  'nick_name': string = undefined;
  @ApiProperty({ description: '性别' })
  @Rule(RuleType['string']().empty(''))
  'gender': string = undefined;
  @ApiProperty({ description: '年龄' })
  @Rule(RuleType['string']().empty(''))
  'age': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '年级' })
  @Rule(RuleType['string']().empty(''))
  'grade': string = undefined;
  @ApiProperty({ description: '出生日期' })
  @Rule(RuleType['string']().empty(''))
  'birth': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_student extends FVO_student {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_student extends CDTO_student {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_student extends FVO_student {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
