import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_teacher {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '微信唯一标识' })
  'openid': string = undefined;
  @ApiProperty({ description: '头像' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '昵称' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '出生日期' })
  'birth': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '身份证照片正反面' })
  'card': Array<any> = undefined;
  @ApiProperty({ description: '学历' })
  'education': string = undefined;
  @ApiProperty({ description: '院校' })
  'college': string = undefined;
  @ApiProperty({ description: '学业状态' })
  'learnStatus': string = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
}

export class QDTO_teacher extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['openid', 'nick_name', 'gender', 'phone', 'education', 'college', 'learnStatus', 'status', 'is_show'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '微信唯一标识' })
  'openid': string = undefined;
  @ApiProperty({ description: '昵称' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '学历' })
  'education': string = undefined;
  @ApiProperty({ description: '院校' })
  'college': string = undefined;
  @ApiProperty({ description: '学业状态' })
  'learnStatus': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
}

export class QVO_teacher extends FVO_teacher {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_teacher {
  @ApiProperty({ description: '微信唯一标识' })
  @Rule(RuleType['string']().empty(''))
  'openid': string = undefined;
  @ApiProperty({ description: '头像' })
  @Rule(RuleType['array']().empty(''))
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '昵称' })
  @Rule(RuleType['string']().empty(''))
  'nick_name': string = undefined;
  @ApiProperty({ description: '性别' })
  @Rule(RuleType['string']().empty(''))
  'gender': string = undefined;
  @ApiProperty({ description: '出生日期' })
  @Rule(RuleType['string']().empty(''))
  'birth': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '身份证照片正反面' })
  @Rule(RuleType['array']().empty(''))
  'card': Array<any> = undefined;
  @ApiProperty({ description: '学历' })
  @Rule(RuleType['string']().empty(''))
  'education': string = undefined;
  @ApiProperty({ description: '院校' })
  @Rule(RuleType['string']().empty(''))
  'college': string = undefined;
  @ApiProperty({ description: '学业状态' })
  @Rule(RuleType['string']().empty(''))
  'learnStatus': string = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
}

export class CVO_teacher extends FVO_teacher {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_teacher extends CDTO_teacher {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_teacher extends FVO_teacher {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
