import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { Course } from '../../entity/core/course.entity';
import { get } from 'lodash';
import { Teacher } from '../../entity/core/teacher.entity';
type modelType = ReturnModelType<typeof Course>;
@Provide()
export class CourseService extends BaseService<modelType> {
  @InjectEntityModel(Course)
  model: modelType;

  @InjectEntityModel(Teacher)
  tModel: ReturnModelType<typeof Teacher>;

  // 列表
  async list(query) {
    const { skip = 0, limit = 0, ...info } = query;
    const data = await this.model.find(info, { meta: 0, __v: 0 }).skip(skip).limit(limit).lean();
    for (const val of data) {
      if (get(val, 'teacher')) {
        const userData = await this.tModel.findById(val.teacher).lean();
        if (userData) Object.assign(val, { teacher_name: userData.nick_name, teacher_phone: userData.phone });
      }
    }
    const total = await this.model.count(info);
    return { data, total };
  }
}
