import { Provide, Inject } from '@midwayjs/decorator';
import { I18nService } from './i18n.service';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { Teacher } from '../entity/core/teacher.entity';
import { Student } from '../entity/core/student.entity';
@Provide()
export class TokenService {
  @Inject()
  i18n: I18nService;

  @InjectEntityModel(Teacher)
  tModel: ReturnModelType<typeof Teacher>;

  @InjectEntityModel(Student)
  sModel: ReturnModelType<typeof Student>;

  //用openid查询用户信息
  async opneid(data) {
    const { openid } = data;
    let info = {};
    const teacher = await this.tModel.findOne({ openid }).lean();
    if (teacher && teacher._id) info = { ...teacher, role_type: 'Teacher' };
    const student = await this.sModel.findOne({ openid }).lean();
    if (student && student._id) info = { ...student, role_type: 'Student' };
    return info;
  }
}
