import { Provide, Inject } from '@midwayjs/decorator';
import { GetModel, ServiceError } from 'free-midway-component';
import { upperFirst } from 'lodash';
import { I18nService } from './i18n.service';
import { FrameErrorEnum } from '../error/frame.error';
@Provide()
export class UtilService {
  @Inject()
  i18n: I18nService;

  randomStr(len = 6) {
    return Math.random().toString(36).slice(-len);
  }

  // 检查创建用户前的openid是否唯一
  async createUserBefor(data, role_type) {
    const { openid } = data;
    const model = GetModel(upperFirst(role_type));
    const result = await model.findOne({ openid }).lean();
    if (result) throw new ServiceError(this.i18n.translateError(FrameErrorEnum.SERVICE_REPEAT), FrameErrorEnum.SERVICE_REPEAT);
  }

  // 修改后信息后用户重新审核
  async updateUserAfter(id, body, role_type) {
    const { is_show, status } = body;
    if (is_show === '0' && status === '0') {
      const model = GetModel(upperFirst(role_type));
      await model.updateOne({ _id: id }, { status: '0' });
    }
  }
}
